package io.accumulatenetwork.sdk.generated.protocol;

/**
    GENERATED BY go run ./tools/cmd/gen-api. DO NOT EDIT.
**/

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonTypeName;
import io.accumulatenetwork.sdk.protocol.AccountAuthOperation;
import io.accumulatenetwork.sdk.protocol.Url;
import io.accumulatenetwork.sdk.support.Marshaller;
// UnionType: AccountAuthOperationType
// UnionValue: Disable

@JsonIgnoreProperties(ignoreUnknown = true)
@JsonTypeName("DisableAccountAuthOperation")
@JsonInclude(JsonInclude.Include.NON_NULL)
public class DisableAccountAuthOperation implements AccountAuthOperation {
	public final AccountAuthOperationType type = AccountAuthOperationType.DISABLE;
	private Url authority;

    //
	public Url getAuthority() {
	    return authority;
	}
	public void setAuthority(final Url value) {
	    this.authority = value;
	}

	public DisableAccountAuthOperation authority(final Url value) {
	    setAuthority(value);
	    return this;
	}
	public DisableAccountAuthOperation authority(final String value) {
	    setAuthority(Url.toAccURL(value));
	    return this;
	}
    public byte[] marshalBinary() {
        final var marshaller = new Marshaller();
        marshaller.writeValue(1, type);
        if (!(this.authority == null)) {
            marshaller.writeUrl(2, this.authority);
        }
        return marshaller.array();
    }
}
